#include <iostream>
#include <memory>
#include <stdio.h>
using namespace std;

#define BUFFER_SIZE 100


class MyData {
  private:
    int count;
    double size;

  public:
    MyData(double s) : count(0), size(s) {}
    friend ostream& operator<<(ostream& os, const MyData& dt);
};

/*
That contructor is equivalent to:
    MyData(double s) {
        count = 0;
        size = s;
    }
*/
ostream& operator<<(ostream& os, const MyData& d) {
    os << '(' << d.count << ',' << d.size << ')';
    return os;
}


void main1() {
    MyData* d = new MyData(1.234);
    cout << *d << '\n';
    delete d;
}


void main2() {
    auto d = make_unique<MyData>(1.234);
    cout << *d << '\n';
}


typedef struct {
    int count;
    double size;
} my_data;

void format_my_data(char* buffer, my_data d) {
    snprintf(buffer, BUFFER_SIZE, "(%d,%g)", d.count, d.size);
}

void main3() {
    char buffer[BUFFER_SIZE];
    my_data d = {0, 1.234};
    format_my_data(buffer, d);
    puts(buffer);
}

void main4() {
    char buffer[BUFFER_SIZE];
    my_data* d = (my_data*)malloc(sizeof(my_data));
    d->count = 0;
    d->size = 1.234;
    format_my_data(buffer, *d);
    puts(buffer);
    free(d);
}


int main() {
    main1();
    main2();
    main3();
    main4();
    return 0;
}
